leetcode 55.跳跃游戏
题目描述:
给定一个非负整数数组,你最初位于数组的第一个位置。
数组中的每个元素代表你在该位置可以跳跃的最大长度。
判断你是否能够到达最后一个位置。
示例 1:
输入: [2,3,1,1,4]
输出: true
解释: 从位置 0 到 1 跳 1 步, 然后跳 3 步到达最后一个位置。
示例 2:
输入: [3,2,1,0,4]
输出: false
解释: 无论怎样,你总会到达索引为 3 的位置。但该位置的最大跳跃长度是 0 , 所以你永远不可能到达最后一个位置。
做法一:
最简单的思维,设置一个boolean型的数组dp[],从后往前推,倒数第二个如果不为0,就初始化为true,否则为false,之后的逻辑就是,如果当前能直接走到最后,或者范围内,dp[]有为true的,就设为true,最后返回dp[0]即可
public boolean canJump(int[] nums) {
int length = nums.length;
if (length == 1) return true;
boolean[] dp = new boolean[length];
Arrays.fill(dp, false);
if (nums[length - 2] != 0) dp[length - 2] = true;
//because the last num is no use, we just need to judge can we get there,
//so i begin at length-2
for (int i = length - 3; i >= 0; i--) {
for (int j = 1; j <= nums[i]; j++) {
if ((i + j) >= length - 1 || dp[i + j] == true) {
dp[i] = true;
break;
}
}
}
return dp[0];
}
但是这一点儿都不贪心,
方法二:
从前往后遍历,每次记录能到达的最远的下标 maxIndex , 一直遍历到最后,返回maxIndex是否>=
数组长度即可
public boolean canJump2(int[] nums) {
if(nums.length <= 1)return true;
int mostFar = 0;
int startIndex = 0;
while (startIndex <= mostFar && mostFar <= nums.length - 1) {
mostFar = Math.max(mostFar, (startIndex + nums[startIndex]));
startIndex++;
}
return mostFar >= nums.length - 1;
}